Attribute VB_Name = "FindFilesModule"
Option Explicit

'FindFile-Funktion
Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Type WIN32_FIND_DATA
   dwFileAttributes   As Long
   ftCreationTime   As FILETIME
   ftLastAccessTime   As FILETIME
   ftLastWriteTime   As FILETIME
   nFileSizeHigh   As Long
   nFileSizeLow   As Long
   dwReserved0   As Long
   dwReserved1   As Long
   cFileName   As String * 255 'MAX_PATH
   cAlternate   As String * 14
End Type

'** Datei-Suchfunktionen
Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
 (ByVal lpPrevWndFunc As Long, _
  ByVal hwnd As Long, ByVal Msg As Long, _
  ByVal wParam As Long, ByVal lParam As Long) As Long
  
Type AFileOfDirFiles
 FullName As String
 ShortName As String
 Path As String
 FileAttributes As Long
 FileSize As Double
End Type
Global TheFile As AFileOfDirFiles

Sub DirFiles(ByVal FileProc As Long, ByVal EndProc As Long, Optional ByVal Verzeichnis As String = "", Optional ByVal Optionen As Integer = 0, Optional ByVal DateiErweiterung As String = "", Optional StoppSearch As Boolean)
 'Werte fr Optionen:
 ' 0 alle Dateien in Hauptverzeichnis und in Unterverzeichnissen listen
 ' 1 alle Dateien im Hauptverzeichnis listen
 ' 2 alle Dateien in Unterverzeichnissen listen
 ' 3 alle Verzeichnisse im Hauptverzeichnis und in Unterverzeichnissen listen
 ' 4 alle Verzeichnisse im Hauptverzeichnis listen
 ' 5 alle Verzeichnisse in Unterverzeichnissen listen
 ' 6 alle Dateien und Verzeichnisse in Hauptverzeichnis und in Unterverzeichnissen listen
 ' 7 alle Dateien und Verzeichnisse im Hauptverzeichnis listen
 ' 8 alle Dateien und Verzeichnisse in Unterverzeichnissen listen
 Dim WFD As WIN32_FIND_DATA
 Dim FHandle&
 Dim ResL&
 Dim X%
 Dim FN$
 If Verzeichnis = "" Then Verzeichnis = App.Path
 If Not Right$(Verzeichnis, 1) = "\" Then Verzeichnis = Verzeichnis + "\"
 If DateiErweiterung = "*" Then DateiErweiterung = ""
 StoppSearch = False
 FHandle& = 0
 FHandle& = FindFirstFile(Verzeichnis + "*.*", WFD)
 ResL& = FHandle&
 Do While ResL&
  FN$ = ZTrim$(WFD.cFileName)
  If Not WFD.dwFileAttributes And 16 Then
   Select Case Optionen
    Case 0, 1, 6, 7
     TheFile.ShortName = FN$
     TheFile.FullName = Verzeichnis + FN$
     TheFile.Path = Verzeichnis
     TheFile.FileAttributes = WFD.dwFileAttributes
     TheFile.FileSize = WFD.nFileSizeLow
     If TheFile.FileSize < 0 Then TheFile.FileSize = 2 * 2147483648# + TheFile.FileSize
     CallWindowProc FileProc, 0, 0, 0, 0
     If StoppSearch Then
      ResL& = FindClose(FHandle&)
      Exit Sub
     End If
   End Select
  Else
   If Left$(FN$, 1) <> "." Then
    Select Case Optionen
     Case 3, 4, 6, 7
      TheFile.ShortName = FN$
      TheFile.FullName = Verzeichnis + FN$
      TheFile.Path = Verzeichnis
      TheFile.FileAttributes = WFD.dwFileAttributes
      TheFile.FileSize = 0
      CallWindowProc FileProc, 0, 0, 0, 0
      If StoppSearch Then
       ResL& = FindClose(FHandle&)
       Exit Sub
      End If
    End Select
    Select Case Optionen
     Case 0, 2
      DirFiles FileProc, 0, Verzeichnis + FN$, 0, DateiErweiterung, StoppSearch
     Case 3, 5
      DirFiles FileProc, 0, Verzeichnis + FN$, 3, DateiErweiterung, StoppSearch
     Case 6, 8
      DirFiles FileProc, 0, Verzeichnis + FN$, 6, DateiErweiterung, StoppSearch
    End Select
    If StoppSearch Then
     ResL& = FindClose(FHandle&)
     Exit Sub
    End If
   End If
  End If
  ResL& = 0
  ResL& = FindNextFile(FHandle&, WFD)
 Loop
 ResL& = FindClose(FHandle&)
 If Not EndProc = 0 Then CallWindowProc EndProc, 0, 0, 0, 0
End Sub

Function ZTrim$(T$)
 Dim Drin%

'** Text T$ am Nullzeichen abschneiden
  ZTrim$ = T$
  Drin% = InStr(T$, Chr$(0))
  If Drin% Then ZTrim$ = Left$(T$, Drin% - 1)
End Function

